<?php
/*
 chat.php (utf-8) PHP 5.4+
 - Webbausteine.de

 Version vom: 12.09.2015
  Eine aktuelle Version finden Sie unter:
  www.webbausteine.de/mysql/mysql_chatroom.php
  Dort können Sie auch Verbesserungsvorschläge, Hinweise und Fehler eintragen.
  Installation der Datenbank-Tabelle, siehe Website!
*/

session_start();
header('Content-Type: text/html; charset=UTF-8');

// Verbindungsdaten zur Datenbank
// Die Verbindungsdaten erhalten Sie von Ihrem Webspace-Provider.
$DB_HOST = "localhost"; // Datenbank-Host
$DB_NAME = "test"; // Datenbank-Name
$DB_USER = "root"; // Datenbank-Benutzer
$DB_PASSWORD = ""; // Datenbank-Passwort

// Namen und Passwörter
// Sie können beliebig viele Benutzer für den Chat hinzufügen.
$NAME_PASS["user"] = "0000";
$NAME_PASS["user2"] = "0002";

// Namen und Farben
// Sie können jedem Benutzer eine andere Farbe zur Anzeige seines Benutzernamens geben.
// Hexadezimale Farbangabe oder Farbnamen (Red Blue, Green, ...) verwenden.
$NAME_COLOR["user"] = "#EE0000";
$NAME_COLOR["user2"] = "#0000EE";

// Chat neu laden nach:
$seconds = 10; // 10 Sekunden

// Anzahl der max. Einträge die angezeigt werden:
$limit = 50; // 50

// Chat leeren nach:
$days = 7; // 7 Tagen

// Benutzer autom. inaktiv nach:
$inactive = 10; // 10 Minuten

// Smileys
$smileys = [
  ':acid:' => '<img src="acid.gif" alt="">',
  ':bigeek:' => '<img src="bigeek.gif" alt="">',
  ':biggrin:' => '<img src="biggrin.gif" alt="">',
  ':bigrazz:' => '<img src="bigrazz.gif" alt="">',
  ':confused:' => '<img src="confused.gif" alt="">',
  ':cool:' => '<img src="cool.gif" alt="">',
  ':cry:' => '<img src="cry.gif" alt="">',
  ':dead:' => '<img src="dead.gif" alt="">',
  ':fuck:' => '<img src="fuck.gif" alt="">',
  ':hello:' => '<img src="hello.gif" alt="">',
  ':holy:' => '<img src="holy.gif" alt="">',
  ':kiss:' => '<img src="kiss.gif" alt="">',
  ':laugh:' => '<img src="laugh.gif" alt="">',
  ':mad:' => '<img src="mad.gif" alt="">',
  ':none:' => '<img src="none.gif" alt="">',
  ':rolleyes:' => '<img src="rolleyes.gif" alt="">',
  ':smile:' => '<img src="smile.gif" alt="">',
  ':thumps:' => '<img src="thumps.gif" alt="">',
  ':wink:' => '<img src="wink.gif" alt="">',
 ];

// BB-Code Buttons
$bbbuttons = [
 'Fettschrift&#10;[b] Text [/b]' => 'b',
 'Unterstrichen&#10;[u] Text [/u]' => 'u',
 'Schriftfarbe&#10;[c=Red] Text [/c]' => 'c',
 'Durchgestrichen&#10;[s] Text [/s]' => 's',
];

function bbCode($text) {
 $text = preg_replace('/\[b\](.*)\[\/b\]/Usi', '<b>$1</b>', $text); // [b]
 $text = preg_replace('/\[u\](.*)\[\/u\]/Usi', '<u>$1</u>', $text); // [u]
 $text = preg_replace('/\[c=(.*)\](.*)\[\/c\]/Usi', '<span style="color:$1">$2</span>', $text); // [c]
 $text = preg_replace('/\[s\](.*)\[\/s\]/Usi', '<s>$1</s>', $text); // [s]
 return $text;
}

function viewBBbuttons($bbbuttons) {
 $a = "";
 foreach ($bbbuttons as $text => $bbbutton):
  $a .= '<button type="button" onClick="setInsert(\'' . $bbbutton . '\')" title="' . $text . '">' . $bbbutton . '</button> ';
 endforeach;
 return $a;
}

function viewSmiley($smileys) {
 $a = '';
 foreach ($smileys as $b => $smiley):
  $a .= str_replace(' alt=""', ' class="smile" onClick="setInsert(\'' . $b . '\')" title="' . $b . '" alt=""', $smiley);
 endforeach;
 return $a;
}

function makeLink($hit) {
 $url = trim($hit[1]);
 if ((substr($url, 0, 7) != 'http://') && (substr($url, 0, 8) != 'https://'))
  $url = 'http://' . $url;
 return ' <a href="' . $url . '" target="_blank">' . $url . '</a>';
}

// Connection
try {
 $db = new PDO("mysql:host=" . $DB_HOST . ";dbname=" . $DB_NAME, $DB_USER, $DB_PASSWORD,
 [PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8"]);
}
catch (PDOException $e) {
 exit('<h4>Verbindung fehlgeschlagen!</h4>' . $e->getMessage());
}

// DB Installation
if (isset($_GET["install"])):
 if ($db->query("CREATE TABLE IF NOT EXISTS `chat` (
                          `name` VARCHAR(25) COLLATE utf8_unicode_ci NOT NULL,
                          `text` TEXT COLLATE utf8_unicode_ci NOT NULL,
                          `online` TINYINT(1) NOT NULL DEFAULT '0',
                          `date` datetime NOT NULL)
                         ENGINE = InnoDB")):
  header('location: chat.php?install_ok');
 else:
  exit('<h4>Fehler bei der Installation!</h4>' . $db->errorInfo()[2]);
 endif;
endif;

// DB Insert
if (isset($_POST["text"])):
 $_POST["text"] = strip_tags(trim($_POST["text"]));
 if (strlen($_POST["text"]) >= 2):
  $insert = $db->prepare("INSERT INTO `chat`
                                       SET `name`= :name,
                                             `text`= :text,
                                             `online`= '1',
                                             `date`= NOW()");
  $insert->execute([':name' => $_SESSION["user"],
                             ':text' => $_POST["text"]]);
 endif;
endif;

// DB Read
if (isset($_GET["read"]) ||
    isset($_POST["text"])):

 // User Set Offline
 $db->exec("UPDATE `chat`
                   SET `online` = '0'
                   WHERE `name` = '" . $_SESSION["user"] . "' AND
                               UNIX_TIMESTAMP() - UNIX_TIMESTAMP(`date`) > " . ($inactive * 60));
 // Read Entries
 $select = $db->query("SELECT `name`, `text`, `online`, `date`
                                    FROM `chat`
                                    ORDER BY `date` DESC
                                    LIMIT " . $limit);
 $entries = $select->fetchAll(PDO::FETCH_ASSOC);

 // Read User Online
 $user = $db->query("SELECT `name`
                                  FROM `chat`
                                  WHERE `online` = '1'
                                  GROUP BY `name`");
 $u = $user->fetchAll(PDO::FETCH_ASSOC);
 print '<small>Online: ';
 foreach ($u as $us):
  print '<i>' . $us["name"] . '</i>, ';
 endforeach;

 // Print Entries
 if ($select->rowCount() > 0):
  print '<br>' . date("d.m - H:i") . ' Uhr</small><br>';
  foreach ($entries as $entry):
   $text = strtr($entry["text"], $smileys);
   $text = bbCode($text);
   $text = preg_replace_callback('#(( |^)(((http|https|)://)|www.)\S+)#mi', 'makeLink', $text);
   sscanf($entry["date"], "%4s-%2s-%2s %5s", $year, $month, $day, $time);
   print '<small>' . $day . '.' . $month . ' - ' . $time . '</small> ' .
    ' <span style="color:' . (isset($NAME_COLOR[$entry["name"]]) ? $NAME_COLOR[$entry["name"]] : '#000000') . '">' .
    $entry["name"] . '</span>: ' . $text . '<br>';
  endforeach;
 endif;
 exit;
endif;

// Password Check
if (isset($_POST["pass"])):
 if (isset($NAME_PASS[$_POST["user"]]) &&
     $NAME_PASS[$_POST["user"]] === $_POST["pass"]):
   $_SESSION["user"] = $_POST["user"];
   // DB Delete
   $db->exec("DELETE FROM `chat`
                     WHERE (TO_DAYS(NOW()) - TO_DAYS(`date`)) > " . $days);
   // User Set Online
   $db->exec("UPDATE `chat`
                     SET `online` = '1'
                     WHERE `name` = '"  . $_POST["user"] . "'");
 endif;
endif;

// Log Out
if (isset($_GET["logout"])):
 // User Set Offline
 $db->exec("UPDATE `chat`
                   SET `online` = '0'
                   WHERE `name` = '" . $_SESSION["user"] . "'");
 session_destroy();
 header('location: chat.php?logout_ok');
endif;
?><!DOCTYPE html>
<html lang="de">
 <head>
  <meta charset="UTF-8">
  <title>Chatroom</title>

  <script>
  "use strict";
  var XHR = window.XMLHttpRequest ?
   new XMLHttpRequest() : new ActiveXObject("Microsoft.XMLHTTP");

  // Send Post
  function post() {
   XHR.open("POST", "chat.php", true);
   var data = new FormData(document.getElementById("form"));
   XHR.send(data);
   document.getElementById("text").value = "";
   document.getElementById("text").focus();
   XHR.onreadystatechange = response;
  }

  // Send Get
  function get() {
   if (document.getElementById("chat") !== null) {
    XHR.open("GET", "chat.php?read", true);
    XHR.send(null);
    XHR.onreadystatechange = response;
   }
  }

  // Response
  function response() {
   if (XHR.readyState == 4 &&
       XHR.status == 200) {
     document.getElementById("chat").innerHTML = XHR.responseText;
    }
  }

  function setInsert(bs) {
   if (document.getSelection) {
    var field = document.getElementById("text");
    var startPos = field.selectionStart;
    var endPos = field.selectionEnd;
    var txt = field.value.substring(startPos, endPos);
    if (bs.substr(0, 1) == ":") {
     field.value = field.value.substring(0, startPos) +
      " " + bs + " " +
      field.value.substring(endPos, field.length);
    }
    else {
     field.value = field.value.substring(0, startPos) +
      "[" + bs + "]" + txt + "[/" + bs + "]" +
      field.value.substring(endPos, field.length);
    }
    field.focus();
   }
  }

  window.addEventListener("load", get);
  window.setInterval("get()", (<?=$seconds;?>*1000));
  </script>

  <style>
  body {
   background-color: Whitesmoke;
   font-family: Verdana, Arial, Sans-Serif;
   color: #000000;
  }

  a:link, a:visited {
   color: Royalblue;
  }

  input#text {
   font-size: 1rem;
   width: 90%;
  }

  button {
   font-family: Arial, Sans-Serif;
   font-size: 0.7rem;
  }

  img.smile {
   cursor: Pointer;
   padding: 0 4px 0 4px;
   vertical-align: Middle;
  }
  </style>

 </head>
<body>

<h3>Chatroom</h3>

<?php
// Log In
if (!isset($_SESSION["user"])):
 if (isset($_GET["logout_ok"])) print '<p>Auf Wiedersehen!</p>';
 if (isset($_GET["install_ok"])) print '<p>Installation erfolgreich!</p>';
 exit ('<form method="post">' .
  '<label>Name: <input type="text" name="user" required="required" autofocus="autofocus"></label><br>' .
  '<label>Pass: &nbsp; <input type="password" name="pass" required="required"></label> ' .
  '<input type="submit" value=" &gt; "></form></body></html>');
endif;
?>

<p><?=viewBBbuttons($bbbuttons) . viewSmiley($smileys);?></p>

<form action="javascript:post()" method="post" id="form">
 <a href="chat.php?logout" title="Zum Abmelden hier klicken!"><?=$_SESSION["user"];?></a>:
 <input type="text" name="text" id="text" autofocus="autofocus" spellcheck="true" title="Text eingeben und Eingabetaste drücken.">
</form>

<p id="chat"></p>

</body>
</html>